#include <bits/stdc++.h>
using namespace std;
typedef long long ull;
ull xor_djelilaca(int n){
    ull x=0;
    for(int i=1; i<=n/2; i++)if(n%i==0)x^=i;
    x^=n;
    return x;
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n,k,a; cin >> n >> k;
    for(int i=0; i<k; i++){cin >> a; cout << xor_djelilaca(a) << '\n';}
    return 0;
}